//=============================================================================
// HUDSpawner
// Author: }TCP{Wolf
//   Date: 2007-12-28
//
// This class is responsible for the actual REPLACING of the HUD on the client.
//
// MOD AUTHORS: Change default properties here to your needs!
//=============================================================================
class HUDSpawner extends ReplicationInfo;

var class<HUD> HudSpawnClass;	// which hud class to actually USE
var int runCounter;	// replace hud on first count, destroy self on second



replication
{
	// server calls this function on client
	Reliable If (Role == Role_Authority)
		ReplaceHUD;
}




// my little customized log function
simulated function l(String what)
{
	log(Role@what,'HUDREPLACER');
}



// called by engine fater game starts
function PostBeginPlay()
{
	l("PostBeginPlay()");
	Super.PostBeginPlay();
	SetTimer(5,true);	// WAIT 5 SECONDS BEFORE REPLACING HUD
}


// replacing the HUD should be time delayed so init can complete
function Timer()
{
	l("Timer()");
	// check alive (server only)
	if (Pawn(Owner)==None)
	{
		l("No Pawn Owner! Self-Terminate!");
		destroy();
		return;
	}

	if (runCounter == 0)
	{
		l("Telling client to replace HUD....");
		ReplaceHUD();
		Settimer(1,true);
	}
	else
	{
		l("HUD should have been replaced already, we are DONE!");
		destroy();
	}

	runCounter++;
}


// actual replacement action takes palce here
// function must be SIMULATED because run on client and
// instigated by server call (replicated)
simulated function ReplaceHUD()
{
	local PlayerPawn p;

	l("Trying to replace HUD on player...");
	p = PlayerPawn(Owner);

	if (p == none)	// this should NOT happen!
	{
		l("Hmm... no player pawn owner here :-(");
		return;
	}

	if (p.HudType != HudSpawnClass)
	{
		p.HudType = HudSpawnClass;
		p.myHUD.destroy();
		p.myHUD = spawn(HudSpawnClass,p);
		l("done...");
	}
	else
		l("already has replaced HUD... nothing todo here.");
}



defaultproperties
{
	runCounter=0
	HudSpawnClass=class'CustomTestHUD'
	RemoteRole=Role_SimulatedProxy
}
