//=============================================================================
// MUT_HUDReplacer
// ============================================================================
// Author: }TCP{Wolf
// Date: 2007-12-28
//
// This class detects when new players enter the server. When this happens,
// the actual HUD SPAWNER class needs to be spawned on top of the entering
// player.
//
// Usage: add "?Mutator=HUDReplacer.MUT_HUDReplacer" in your server startup
//        line
//=============================================================================
class MUT_HUDReplacer extends Mutator;


// my little customized log function
function l(String what)
{
	log(Role@what,'HUDREPLACER');
}


/* MUTATOR function
   This function is always called by the engine.
   It is used here to determine if a new player has joined.
*/
function bool IsRelevant(Actor Other, out byte bSuperRelevant)
{
	local HUDSpawner spawner;
	local PlayerPawn p;

	if (Other.IsA('PlayerPawn'))
	{
		p = PlayerPawn(Other);

		l("Spawning HUD Replacer on new player");
		spawner = Spawn(class'HUDSpawner',p);
		if (spawner == none)
		{
			l("Spawn failure for HUD spawner :-(");
			// TODO: what now...?
		}
	}

	return super.IsRelevant(Other, bSuperRelevant);
}

